<template>
  <v-form>
    <v-container fluid>
      <v-row>
        <v-col cols="12" sm="6" md="6">
          <v-text-field
            v-model.number="item.quantity"
            :error-messages="quantityErrors"
            :label="$t('quantity')"
            @input="$v.item.quantity.$touch()"
            @blur="$v.item.quantity.$touch()"
          />
        </v-col>
      
        <v-col cols="12" sm="6" md="6">
          <v-combobox
            v-model="item.product"
            :items="productSelectItems"
            :error-messages="productErrors"
            :no-data-text="$t('No results')"
            :label="$t('product')"
            item-text="name"
            item-value="@id"
          />
        </v-col>
      </v-row>
      
      <v-row>
        <v-col cols="12" sm="6" md="6">
          <v-combobox
            v-model="item.order"
            :items="orderSelectItems"
            :error-messages="orderErrors"
            :no-data-text="$t('No results')"
            :label="$t('order')"
            item-text="name"
            item-value="@id"
          />
        </v-col>
      
        <v-col cols="12"></v-col>
      </v-row>
      
    </v-container>
  </v-form>
</template>

<script>
import has from 'lodash/has';
import { validationMixin } from 'vuelidate';
//import { required } from 'vuelidate/lib/validators';
import { mapActions } from 'vuex';
import { mapFields } from 'vuex-map-fields';

export default {
  name: 'ComposeForm',
  mixins: [validationMixin],
  props: {
    values: {
      type: Object,
      required: true
    },

    errors: {
      type: Object,
      default: () => {}
    },

    initialValues: {
      type: Object,
      default: () => {}
    }
  },
  mounted() {
      this.productGetSelectItems();
      this.orderGetSelectItems();
  },
  data() {
    return {
        quantity: null,
        product: null,
        order: null,
    };
  },
  computed: {
      ...mapFields('product', {
        productSelectItems: 'selectItems'
      }),
      ...mapFields('order', {
        orderSelectItems: 'selectItems'
      }),

    // eslint-disable-next-line
    item() {
      return this.initialValues || this.values;
    },

    quantityErrors() {
      const errors = [];

      if (!this.$v.item.quantity.$dirty) return errors;

      has(this.violations, 'quantity') && errors.push(this.violations.quantity);


      return errors;
    },
    productErrors() {
      const errors = [];

      if (!this.$v.item.product.$dirty) return errors;

      has(this.violations, 'product') && errors.push(this.violations.product);


      return errors;
    },
    orderErrors() {
      const errors = [];

      if (!this.$v.item.order.$dirty) return errors;

      has(this.violations, 'order') && errors.push(this.violations.order);


      return errors;
    },

    violations() {
      return this.errors || {};
    }
  },
  methods: {
      ...mapActions({
        productGetSelectItems: 'product/fetchSelectItems'
      }),
      ...mapActions({
        orderGetSelectItems: 'order/fetchSelectItems'
      }),
  },
  validations: {
    item: {
      quantity: {
      },
      product: {
      },
      order: {
      },
    }
  }
};
</script>
